//
// Created by zx on 23-3-14.
//

#ifndef NAVIGATION_MPC_MONITOR_MONITOR_EMQX_H_
#define NAVIGATION_MPC_MONITOR_MONITOR_EMQX_H_

#include <mutex>
#include "terminator_emqx.h"


class Monitor_emqx : public Terminator_emqx
{
public:
    enum ActionMode{
        eSingle=1,
        eMain
    };
    enum ActionType{
        eStop=0,
        eRotate=1,
        eHorizontal=2,
        eVertical=3,
        eClampClode=5,
        eClampOpen=6


    };
 public:
    Monitor_emqx(std::string nodeId);
    ~Monitor_emqx();
    void set_speedcmd_topic(std::string speedcmd);
    void set_speed(ActionMode mode,ActionType type,double v,double a);
    void set_speed(ActionMode mode,ActionType type,double v,double a,double L);
    void clamp_close(ActionMode mode);
    void clamp_open(ActionMode mode);
    void stop();

 protected:


    std::string speedcmd_topic_;

 public:
    int heat_=0;

};


#endif //NAVIGATION_MPC_MONITOR_MONITOR_EMQX_H_
